import { objectWithoutProperties as _objectWithoutProperties, extends as _extends } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { jsx } from '@emotion/core';
import React__default from 'react';
import { inputLeftIconCss, baseInputCss, inputWithLeftIconCss } from '../../styles/index.esm.js';

var StyledInput = React__default.forwardRef(function InputFieldControl(_ref, ref) {
  var _ref$as = _ref.as,
      Component = _ref$as === void 0 ? "input" : _ref$as,
      LeftIcon = _ref.LeftIcon,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ["as", "LeftIcon", "className"]);

  var placeholder = props.placeholder && props.disabled ? "The field is disabled" : props.placeholder;

  var baseCss = function baseCss(theme) {
    return [baseInputCss(theme), {
      width: "100%"
    }, LeftIcon && inputWithLeftIconCss(theme)];
  };

  return jsx("div", {
    className: className,
    css: {
      position: "relative"
    }
  }, LeftIcon && jsx(LeftIcon, {
    css: inputLeftIconCss,
    size: "inherit",
    "aria-hidden": true
  }), jsx(Component, _extends({
    ref: ref,
    css: baseCss
  }, props, {
    placeholder: placeholder
  })));
});
StyledInput.__docgenInfo = {
  "description": "",
  "methods": [],
  "displayName": "StyledInput",
  "props": {
    "as": {
      "defaultValue": {
        "value": "`input`",
        "computed": false
      },
      "required": false
    }
  }
};

if (typeof STORYBOOK_REACT_CLASSES !== "undefined") {
  STORYBOOK_REACT_CLASSES["src/components/form/components/styled-primitives/StyledInput.tsx"] = {
    name: "StyledInput",
    docgenInfo: StyledInput.__docgenInfo,
    path: "src/components/form/components/styled-primitives/StyledInput.tsx"
  };
}

export { StyledInput };
//# sourceMappingURL=StyledInput.esm.js.map
